VERSION 5.00
Object = "{024E7654-EC20-495A-862B-08B52EF814CE}#1.0#0"; "VBFLXGRD11.OCX"
Object = "{0E59F1D2-1FBE-11D0-8FF2-00A0D10038BC}#1.0#0"; "msscript.ocx"
Begin VB.Form Form1 
   Caption         =   "VBFlexGrid + FlexSpread (with Script control)"
   ClientHeight    =   3990
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   15330
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   15330
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox Text1 
      BackColor       =   &H0000FFFF&
      Height          =   360
      Left            =   5970
      TabIndex        =   3
      Top             =   135
      Width           =   1065
   End
   Begin VB.CommandButton cmdCalculate 
      Caption         =   "Calculate"
      Height          =   360
      Left            =   3120
      TabIndex        =   2
      Top             =   120
      Width           =   1140
   End
   Begin VB.CommandButton cmdAddValues 
      Caption         =   "Add values"
      Height          =   360
      Left            =   1050
      TabIndex        =   1
      Top             =   120
      Width           =   1140
   End
   Begin MSScriptControlCtl.ScriptControl ScriptControl1 
      Left            =   0
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
   End
   Begin VBFLXGRD11.VBFlexGrid VBFlexGrid1 
      Height          =   3210
      Left            =   120
      TabIndex        =   0
      Top             =   570
      Width           =   7650
      _ExtentX        =   13494
      _ExtentY        =   5662
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents cFlexSpread As clsFlexSpread
Attribute cFlexSpread.VB_VarHelpID = -1

Private Sub cFlexSpread_AfterEdit(Row As Long, Col As Long)
  Debug.Print "AfterEdit", Row, Col
End Sub

Private Sub cFlexSpread_BeforeEdit(Row As Long, Col As Long, Cancel As Boolean)
  Debug.Print "Before", Row, Col
  ' lock column 3
  If Col = 3 Then
    VBFlexGrid1.TextMatrix(0, Col) = "LOCKED"
    Cancel = True
  End If
End Sub

Private Sub cFlexSpread_EvalError(Row As Long, Col As Long)
  Debug.Print "EvalError", Row, Col
End Sub

Private Sub cmdAddValues_Click()
  Dim lCol As Long
  
  VBFlexGrid1.TextMatrix(1, 0) = "Nr."
  For lCol = 1 To VBFlexGrid1.Cols - 1
    cFlexSpread.TextFormula(1, lCol) = CStr(lCol)
  Next lCol
  
  VBFlexGrid1.TextMatrix(2, 0) = "Sin"
  For lCol = 1 To VBFlexGrid1.Cols - 1
    cFlexSpread.TextFormula(2, lCol) = "=Sin(" & lCol * 10 & ")"
  Next lCol

  VBFlexGrid1.TextMatrix(3, 0) = "Cos"
  For lCol = 1 To VBFlexGrid1.Cols - 1
    cFlexSpread.TextFormula(3, lCol) = "=Cos(" & lCol * 10 & ")"
  Next lCol
End Sub

Private Sub cmdCalculate_Click()
  Dim lCol As Long
  
  VBFlexGrid1.TextMatrix(4, 0) = "Sum"
  VBFlexGrid1.TextMatrix(5, 0) = "Avg"
  For lCol = 1 To VBFlexGrid1.Cols - 1
    cFlexSpread.TextFormula(4, lCol) = "=sum([1," & lCol & "]:[3," & lCol & "])"
    cFlexSpread.TextFormula(5, lCol) = "=avg([1," & lCol & "]:[3," & lCol & "])"
  Next lCol
End Sub


Private Sub Form_Load()
  Set cFlexSpread = New clsFlexSpread
  
  With VBFlexGrid1
    .Cols = 10
    .Rows = 10
    .ColWidth(-1) = .ColWidth(1) * 1.3
  End With
  
  With cFlexSpread
    Set .EditBox = Text1
    Set .Grid = VBFlexGrid1
    Set .Parser = ScriptControl1
    .AutoEdit = True
    .NumberFormat = "0.00"
  End With
End Sub

Private Sub Form_Resize()
    With VBFlexGrid1
        .Width = ScaleWidth - .Left * 2
        .Height = ScaleHeight - .Top - .Left
    
    End With
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Set cFlexSpread = Nothing
End Sub

